/*
Rob W (http://stackoverflow.com/questions/7443578/youtube-iframe-api-how-do-i-control-a-iframe-player-thats-already-in-the-html/7513356#7513356)
http://code.google.com/apis/youtube/js_api_reference.html
http://code.google.com/apis/youtube/iframe_api_reference.html
http://code.google.com/apis/ajax/playground/?exp=youtube#polling_the_player
http://code.google.com/p/gdata-samples/source/browse/trunk/ytplayer/iframe/index.js

*/

function onPlayerReady(event) {
	//console.log('onPlayerReady ', ytPlayer);
	if(ytPlayer && ytAutoplay) ytPlayer.playVideo();
}

function onPlayerPlaybackQualityChange(event) {
	//console.log('onPlayerPlaybackQualityChange ');
}

function onPlayerStateChange(event) {
	
	//console.log('event.data = ', event.data);
	
	if(event.data == 1){
		ytPlayerState = 1;
	}
	
	if(event.data == 0){
		//console.log('yt ended');
		jQuery.accordionGallery.ytEnd();
	}
	
	/*
	
	YT.PlayerState.ENDED
    YT.PlayerState.PLAYING
    YT.PlayerState.PAUSED
    YT.PlayerState.BUFFERING
    YT.PlayerState.CUED
	
    -1 (unstarted)
    0 (ended)
    1 (playing)
    2 (paused)
    3 (buffering)
    5 (video cued).
	*/
}

function onPlayerError(event) {
	
	/*
	event.data
	 2 – The request contains an invalid parameter value. For example, this error occurs if you specify a video ID that does not have 11 characters, or if the video ID contains invalid characters, such as exclamation points or asterisks.
    100 – The video requested was not found. This error occurs when a video has been removed (for any reason) or has been marked as private.
    101 – The owner of the requested video does not allow it to be played in embedded players.
    150 – This error is the same as 101. It's just a 101 error in disguise!
	*/
	
}

var ytPlayer;
var ytFrameId;
var ytAutoplay=false;
var ytPlayerState = '';


function onYouTubePlayerAPIReady() {
	//console.log('onYouTubePlayerAPIReady');
	ytPlayer = new YT.Player(ytFrameId, {
		events: {
			'onReady': onPlayerReady,
			  'onPlaybackQualityChange': onPlayerPlaybackQualityChange,
			  'onStateChange': onPlayerStateChange,
			  'onError': onPlayerError
		}
	});
}
	
function YoutubePlayerStop(){
	if(ytPlayer) {
		ytPlayer.stopVideo();
	}
}


	
function YoutubePlayer (frameId, ap, id){
		
	ytFrameId = frameId;	
	ytAutoplay = ap;
	ytPlayerState = '';
	
	if(!ytPlayer){	
		         
		var tag = document.createElement('script');
		 tag.src = "http://www.youtube.com/player_api";
		 var firstScriptTag = document.getElementsByTagName('script')[0];
		 //console.log(tag,  firstScriptTag, firstScriptTag.parentNode);
		 firstScriptTag.parentNode.insertBefore(tag, firstScriptTag);
	 
	}else{
		
		if(ytAutoplay){
			ytPlayer.loadVideoById(id);
		}else{
			ytPlayer.cueVideoById(id);
		}
		
	}
};

